// MENUS
//
//

menuAddTabsScript = '
	menu_addtablink("Main", "
		instance_create(x,y,carriers.OptionMenu);
		instance_destroy();
	");
	if(global.isHost) {
		menu_addtablink("Forbid/Ban", "
			instance_create(x,y,carriers.BanMenu);
			instance_destroy();
		");
		menu_addtablink("Constants", "
			instance_create(x,y,carriers.ConstMenu);
			instance_destroy();
		");
	} else {
		menu_addtablink("Forbid", "
			instance_create(x,y,carriers.BanMenu);
			instance_destroy();
		");
		menu_addtablink("Constants", "
			instance_create(x,y,carriers.ConstMenuClient);
			instance_destroy();
		");
	}
';

// MAIN OPTION MENU
//
OptionMenu = object_add();
object_set_parent(OptionMenu,MenuController);  
object_set_depth(OptionMenu,-130000); 
object_event_add(OptionMenu,ev_create,0,'   
	menu_create(48, 172, 500, 260, 32, 40, 104, 6);
	menumode = true;
	
	if room != Options {
		menu_setdimmed();
	}
	
	menu_background(512, 24, 8, 12, 4);
    bgtabs = true;
	
	menu_addedit_boolean("Allow carrying", "carriers.carryEnable", "
        return argument0;
    ");
	
	menu_addedit_key("Grab Key", "carriers.grabKey");
	menu_addlink("The key used to carry/jump on the back of a teammate", "");
	
	menu_addedit_key("Run/Shoot Key", "carriers.modeKey");
	menu_addlink("When carrying someone, use this key to run faster/use your weapon", "");

	' + menuAddTabsScript + '

    menu_addback("Back", "
        instance_destroy();
        if(room == Options)
            room_goto_fix(Menu);
        else
            instance_create(0,0,InGameMenuController);
    ");
');

object_event_add(OptionMenu,ev_destroy,0,'
	with(carriers) {
		ini_open("gg2.ini");
		ini_write_real("Plugins","carriers_grabKey",grabKey);
		ini_write_real("Plugins","carriers_modeKey",modeKey);
		ini_write_real("Plugins","carriers_enable",carryEnable);
		ini_close();
		if(room != Options) {
			global.myself.carryEnable = carryEnable;
			// I KNOW NETWORKING HERE IS BAD BUT WHATEVER
			var enableByte;
			if(carryEnable)	enableByte = carriers.CARRY_ENABLE;
			else			enableByte = carriers.CARRY_DISABLE;
			if(global.isHost) {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
				write_ubyte(carriers.NetworkController.sendBuffer, ds_list_find_index(global.players, global.myself));
			} else {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
			}
		}
	}
');

// BAN OPTION MENU
//
BanMenu = object_add();
object_set_parent(BanMenu,MenuController);  
object_set_depth(BanMenu,-130000); 
object_event_add(BanMenu,ev_create,0,'   
	menu_create(48, 172, 500, 260, 32, 40, 104, 6);
	menumode = true;
	
	if room != Options {
		menu_setdimmed();
	}
	
	menu_background(512, 24, 8, 12, 4);
    bgtabs = true;
	
	
	if(ds_list_size(global.players) > 1) {
	
		if(global.isHost) {
			selectedPlayer = ds_list_find_value(global.players, 1);
		} else {
			selectedPlayer = ds_list_find_value(global.players, 0);
		}
	
		// PLAYER SELECTION
		var i, p;
		menu_addedit_select("Select player:", "selectedPlayer", "return argument0;");
		for(i = 0; i < ds_list_size(global.players); i+=1) {
			p = ds_list_find_value(global.players, i);
			if(p != global.myself) {
				menu_add_option(p, p.name + ", " + execute_string(carriers.getTeamName, p.team) + ", " + execute_string(carriers.getClassName, p.class));
			}
		}
		
		// FORBID
		menu_addlink("FORBID  - Prevent this player from carrying you", "
			if(global.isHost) {
				execute_string(carriers.sendForbid, global.myself, selectedPlayer, carriers.NetworkController.sendBuffer);
				execute_string(carriers.doForbid, global.myself, selectedPlayer);
			} else {
				execute_string(carriers.inputForbid, selectedPlayer, carriers.NetworkController.sendBuffer);
			}
		");
		
		// ALLOW
		menu_addlink("ALLOW   - Allow this player to carry you", "
			if(global.isHost) {
				execute_string(carriers.sendAllow, global.myself, selectedPlayer, carriers.NetworkController.sendBuffer);
				execute_string(carriers.doAllow, global.myself, selectedPlayer);
			} else {
				execute_string(carriers.inputAllow, selectedPlayer, carriers.NetworkController.sendBuffer);
			}
		");
		
		// BAN
		if(global.isHost) {
			menu_addlink("BAN     - HOST -- PREVENT THIS PLAYER FROM CARRYING ANYONE", "
				if(global.isHost) {
					execute_string(carriers.sendBan, selectedPlayer, carriers.NetworkController.sendBuffer);
					execute_string(carriers.doBan, selectedPlayer);
				}
			");
		}
		// UNBAN
		if(global.isHost) {
			menu_addlink("UNBAN   - HOST -- Allow this player to carry anyone", "
				if(global.isHost) {
					execute_string(carriers.sendUnban, selectedPlayer, carriers.NetworkController.sendBuffer);
					execute_string(carriers.doUnban, selectedPlayer);
				}
			");
		}
	}

	' + menuAddTabsScript + '

    menu_addback("Back", "
        instance_destroy();
        if(room == Options)
            room_goto_fix(Menu);
        else
            instance_create(0,0,InGameMenuController);
    ");
');

object_event_add(BanMenu,ev_draw,0,'
	event_inherited();
	var i, str;
	
	draw_set_halign(fa_left);
	draw_set_valign(fa_top);
	
	draw_set_alpha(0.5);
	draw_set_color(c_black);
	draw_rectangle(view_xview[0] + 30, view_yview[0] + 360,
		view_xview[0] + view_wview[0] / 2 - 10, view_yview[0] + view_hview[0] - 40, false);
		
	draw_set_alpha(1);
	draw_set_color(c_white);
	str = "Forbidden players:";
	for(i = 0; i < ds_list_size(global.myself.forbiddenCarriers); i+=1) {
		str += "#" + ds_list_find_value(global.myself.forbiddenCarriers, i).name;
	}
	draw_text(view_xview[0] + 34, view_yview[0] + 364, str);
		
	if(global.isHost) {
		draw_set_alpha(0.5);
		draw_set_color(c_black);
		draw_rectangle(view_xview[0] + view_wview[0] / 2 + 10, view_yview[0] + 360,
			view_xview[0] + view_wview[0] - 30, view_yview[0] + view_hview[0] - 40, false);
			
		draw_set_alpha(1);
		draw_set_color(c_white);
		str = "Banned players:";
		with(Player) {
			if(carryForbidden) {
				str += "#" + name;
			}
		}
		draw_text(view_xview[0] + view_wview[0] / 2 + 14, view_yview[0] + 364, str);
	}
');



// CONSTANTS OPTIONS
//
//
ConstMenu = object_add();
object_set_parent(ConstMenu,MenuController);  
object_set_depth(ConstMenu,-130000); 
object_event_add(ConstMenu,ev_create,0,'   
	menu_create(48, 172, 500, 320, 32, 40, 104, 6);
	menumode = true;
	
	if room != Options {
		menu_setdimmed();
	}
	
	menu_background(512, 24, 8, 12, 4);
    bgtabs = true;
	
	rspp = carriers.RUN_SLOWDOWN_PER_PLAYER * 100;
	sspp = carriers.SHOOT_SLOWDOWN_PER_PLAYER * 100;
	rs = carriers.RUN_SLOWDOWN * 100;
	is = carriers.INTEL_SLOWDOWN * 100;
	ss = carriers.SHOOT_SLOWDOWN * 100;
	ms = carriers.MIN_SPEED * 100;
	smh = carriers.STACK_MAX_HEIGHT;
	hh = carriers.HEAVIER_HP;
	
	if(not global.isHost)
		menu_addlink("These values can not be modified.","");
	menu_addlink("All values here are percentages (%) between 0 and 100.","");
	
	menu_addedit_num("RUN_SLOWDOWN_PER_PLAYER",					"rspp", "return argument0;", 100);
	menu_addedit_num("SHOOT_SLOWDOWN_PER_PLAYER",				"sspp", "return argument0;", 100);
	menu_addedit_num("RUN_SLOWDOWN",							"rs", "return argument0;", 100);
	menu_addedit_num("INTEL_SLOWDOWN",							"is", "return argument0;", 100);
	menu_addedit_num("SHOOT_SLOWDOWN",							"ss", "return argument0;", 100);
	menu_addedit_num("MIN_SPEED",								"ms", "return argument0;", 100);
	menu_addedit_num("STACK_MAX_HEIGHT",						"smh", "return argument0;", 255);
	menu_addedit_boolean("HEAVIER_HP (more maxHp, less speed)",	"hh", "return argument0;");

	' + menuAddTabsScript + '
	
    menu_addback("Back", "
        instance_destroy();
        if(room == Options)
            room_goto_fix(Menu);
        else
            instance_create(0,0,InGameMenuController);
    ");
');

object_event_add(ConstMenu,ev_destroy,0,'
	with(carriers) {
		ini_open("gg2.ini");
		ini_write_real("Plugins","carriers_RUN_SLOWDOWN_PER_PLAYER",	other.rspp / 100);
		ini_write_real("Plugins","carriers_SHOOT_SLOWDOWN_PER_PLAYER",	other.sspp / 100);
		ini_write_real("Plugins","carriers_RUN_SLOWDOWN",				other.rs / 100);
		ini_write_real("Plugins","carriers_INTEL_SLOWDOWN",				other.is / 100);
		ini_write_real("Plugins","carriers_SHOOT_SLOWDOWN",				other.ss / 100);
		ini_write_real("Plugins","carriers_MIN_SPEED",					other.ms / 100);
		ini_write_real("Plugins","carriers_STACK_MAX_HEIGHT",			other.smh);
		ini_write_real("Plugins","carriers_HEAVIER_HP",					other.hh);
		ini_close();
		
		RUN_SLOWDOWN_PER_PLAYER			= other.rspp / 100;
		SHOOT_SLOWDOWN_PER_PLAYER		= other.sspp / 100;
		RUN_SLOWDOWN					= other.rs / 100;
		INTEL_SLOWDOWN					= other.is / 100;
		SHOOT_SLOWDOWN					= other.ss / 100;
		MIN_SPEED						= other.ms / 100;
		STACK_MAX_HEIGHT				= other.smh;
		HEAVIER_HP						= other.hh;
		
		
		if(room != Options) {
			execute_string(carriers.sendUpdateConsts);
		}
	}
');

// SEE CONSTS AS CLIENT
//
//
ConstMenuClient = object_add();
object_set_parent(ConstMenuClient,ConstMenu);  
object_set_depth(ConstMenuClient,-130000); 
object_event_add(ConstMenuClient,ev_destroy,0,'');

// ADD TO IG MENUCONTROLLER
//
//
object_event_add(InGameMenuController,ev_create,0,'
	menu_addlink("Carriers Options", "
		instance_destroy();
		instance_create(0,0,carriers.OptionMenu);
	");
');