/// SCRIPTS
//
//


// returns the string value of a key bind
// argument0: the key value
getKeyStr = '
	switch (argument0)
	{
	case vk_alt:		return "Alt";
	case vk_control:	return "Control";
	case vk_down:		return "Down";
	case vk_up:			return "Up";
	case vk_left:		return "Left";
	case vk_right:		return "Right";
	case vk_enter:		return "Enter";
	case vk_tab:		return "Tab";
	case vk_space:		return "Space Bar";
	case vk_shift:		return "Shift";
	case MOUSE_LEFT:	return "Left Mouse Button";
	case MOUSE_RIGHT:	return "Right Mouse Button";
	default:			return chr(argument0);
	}
';

// returns class name from constant
// argument0: the class constant
getClassName = '
	switch(argument0) {
		case CLASS_SCOUT:		return "Runner";
		case CLASS_PYRO:		return "Firebug";
		case CLASS_SOLDIER:		return "Rocketman";
		case CLASS_HEAVY:		return "Overweight";
		case CLASS_DEMOMAN:		return "Detonator";
		case CLASS_MEDIC:		return "Healer";
		case CLASS_ENGINEER:	return "Constructor";
		case CLASS_SPY:			return "Infiltrator";
		case CLASS_SNIPER:		return "Rifleman";
		case CLASS_QUOTE:		return "Q/C";
	}
	return "";
';

// returns team name from constant
// argument0: the team constant
getTeamName = '
	switch(argument0) {
		case TEAM_RED:			return "RED";
		case TEAM_BLUE:			return "BLU";
		case TEAM_SPECTATOR:	return "Spectator";
	}
	return "";
';

// gets closest carryable Character from Player arg0
// argument0: Player
getCarryable = '
	var closestChar, charDist, thatDist, sendingPlayer;
	sendingPlayer = argument0;
	closestChar = noone;
	if(not sendingPlayer.carryForbidden)
	if(sendingPlayer.object != -1)
	if(sendingPlayer.object.carry == noone) 
	if(sendingPlayer.object.carrier == noone) {
		charDist = 30;
		with(Character) {
			if(id != sendingPlayer.object)
			if((team == sendingPlayer.team) or ((player.class == CLASS_QUOTE) and not (sendingPlayer.object.cloak)))
			if(player.carryEnable)
			if(ds_list_find_index(player.forbiddenCarriers, sendingPlayer) < 0) // if that player did not forbid sendingPlayer to carry them (aka put them in their forbid list)
			if(execute_string(carriers.stackHeight, id) < carriers.STACK_MAX_HEIGHT)
			if(carrier == noone) {
				
				thatDist = distance_to_object(sendingPlayer.object);
				if(thatDist < charDist) {
					if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	Obstacle, true, false) <= 0)
					if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	IntelGate, true, false) <= 0)
					if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	TeamGate, true, false) <= 0)
					if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	PlayerWall, true, false) <= 0) {
						charDist = thatDist;
						closestChar = id;
					}
				}
			}
		}
		if(closestChar != noone) {
			closestChar = closestChar.player;
		}
	}
	return closestChar;
';

// returns how much health Characters have in the stack where arg0 is
// argument0: a Character
stackHealth = '
	var carrier, carry, totalhp;
	carrier = argument0;
	totalhp = 0;
	while(carrier != noone) {
		totalhp += carrier.hp;
		carrier = carrier.carry;
	}
	carry = argument0.carry;
	while(carry != noone) {
		totalhp += carry.hp;
		carry = carry.carrier;
	}
	return totalhp;
';

// returns how much MAX health Characters have in the stack where arg0 is
// argument0: a Character
stackMaxHealth = '
	var carrier, carry, totalhp;
	carrier = argument0;
	totalhp = 0;
	while(carrier != noone) {
		totalhp += carrier.maxHp;
		carrier = carrier.carry;
	}
	carry = argument0.carry;
	while(carry != noone) {
		totalhp += carry.maxHp;
		carry = carry.carrier;
	}
	return totalhp;
';

// returns how many Characters are in the stack where arg0 is
// argument0: a Character
stackHeight = '
	var carrier, carry, height;
	carrier = argument0;
	height = 0;
	while(carrier != noone) {
		height += 1;
		carrier = carrier.carrier;
	}
	carry = argument0.carry;
	while(carry != noone) {
		height += 1;
		carry = carry.carry;
	}
	return height;
';

// returns whether a Character in the carry stack has intel
// argument0: a Character
stackHasIntel = '
	var carrier;
	carrier = argument0;
	while(carrier != noone) {
		if(carrier.intel) {
			return true;
		}
		carrier = carrier.carry;
	}
	return false;
';

// checks if argument0 (Player) can grab argument1 (Player)
// basic check: 
checkGrab = '
	var sending, grabbed;
	sending = argument0;
	grabbed = argument1;
	if(sending != noone)
	if(grabbed != noone)
	if(grabbed.carryEnable)
	if(sending.object != -1)
	if(grabbed.object != -1)
		return true;
	return false;
';

// creates a new notification with specified text and destroys older ones
// arg0: text to be displayed
showNotification = '
	with(carriers.Notification) instance_destroy();
	with(instance_create(0, 0, carriers.Notification)) {
		text = argument0;
	}
';

// gets the first Character of a stack -- the one who can walk
// arg0: a Character in the stack
getStackBottom = '
	var char;
	char = argument0;
	while(char.carrier != noone) {
		char = char.carrier;
	}
	return char;
';